require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_HARDIRQ_H)) {
    eval 'sub __ASM_HARDIRQ_H () {1;}' unless defined(&__ASM_HARDIRQ_H);
    require 'linux/config.ph';
    require 'linux/threads.ph';
    require 'asm/lowcore.ph';
    require 'linux/sched.ph';
    require 'linux/irq_cpustat.ph';
    eval 'sub in_interrupt () {
        eval q(({ \'int\'  &__cpu =  &smp_processor_id(); ( &local_irq_count( &__cpu) +  &local_bh_count( &__cpu) != 0); }));
    }' unless defined(&in_interrupt);
    eval 'sub in_irq () {
        eval q(( &local_irq_count( &smp_processor_id()) != 0));
    }' unless defined(&in_irq);
    unless(defined(&CONFIG_SMP)) {
	eval 'sub hardirq_trylock {
	    my($cpu) = @_;
    	    eval q(( &local_irq_count($cpu) == 0));
	}' unless defined(&hardirq_trylock);
	eval 'sub hardirq_endlock {
	    my($cpu) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&hardirq_endlock);
	eval 'sub hardirq_enter {
	    my($cpu) = @_;
    	    eval q(( &local_irq_count($cpu)++));
	}' unless defined(&hardirq_enter);
	eval 'sub hardirq_exit {
	    my($cpu) = @_;
    	    eval q(( &local_irq_count($cpu)--));
	}' unless defined(&hardirq_exit);
	eval 'sub synchronize_irq () {
	    eval q( &do { }  &while (0));
	}' unless defined(&synchronize_irq);
    } else {
	require 'asm/atomic.ph';
	require 'asm/smp.ph';
	eval 'sub release_irqlock {
	    my($cpu) = @_;
    	    eval q({  &if ( &atomic_read( &global_irq_holder) == $cpu) {  &atomic_set( &global_irq_holder, &NO_PROC_ID);  &atomic_set( &global_irq_lock,0); } });
	}' unless defined(&release_irqlock);
	eval 'sub hardirq_enter {
	    my($cpu) = @_;
    	    eval q({ ++ &local_irq_count($cpu);  &atomic_inc( &global_irq_count); });
	}' unless defined(&hardirq_enter);
	eval 'sub hardirq_exit {
	    my($cpu) = @_;
    	    eval q({  &atomic_dec( &global_irq_count); -- &local_irq_count($cpu); });
	}' unless defined(&hardirq_exit);
	eval 'sub hardirq_trylock {
	    my($cpu) = @_;
    	    eval q({ ! &atomic_read( &global_irq_count)  && ! &atomic_read( &global_irq_lock); });
	}' unless defined(&hardirq_trylock);
	eval 'sub hardirq_endlock {
	    my($cpu) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&hardirq_endlock);
    }
}
1;
