require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_S390_PGALLOC_H)) {
    eval 'sub _S390_PGALLOC_H () {1;}' unless defined(&_S390_PGALLOC_H);
    require 'linux/config.ph';
    require 'asm/processor.ph';
    require 'linux/threads.ph';
    eval 'sub pgd_quicklist () {( ($S390_lowcore->{cpu_data}->{pgd_quick}));}' unless defined(&pgd_quicklist);
    eval 'sub pmd_quicklist () {(0);}' unless defined(&pmd_quicklist);
    eval 'sub pte_quicklist () {( ($S390_lowcore->{cpu_data}->{pte_quick}));}' unless defined(&pte_quicklist);
    eval 'sub pgtable_cache_size () {( ($S390_lowcore->{cpu_data}->{pgtable_cache_sz}));}' unless defined(&pgtable_cache_size);
    eval 'sub get_pgd_fast {
        my($void) = @_;
	    eval q({ my $long * &ret =  &pgd_quicklist;  &if ( &ret !=  &NULL) {  &pgd_quicklist = (* &ret);  $ret[0] =  $ret[1];  &pgtable_cache_size -= 2; } ( &pgd_t *) &ret; });
    }' unless defined(&get_pgd_fast);
    eval 'sub pgd_t {
        eval q(* &pgd_alloc(\'struct mm_struct\' * &mm) {  &pgd_t * &pgd;  &pgd =  &get_pgd_fast();  &if (! &pgd)  &pgd =  &get_pgd_slow();  &pgd; });
    }' unless defined(&pgd_t);
    eval 'sub free_pgd_fast {
        my($pgd) = @_;
	    eval q({ *$pgd =  &pgd_quicklist;  &pgd_quicklist = $pgd;  &pgtable_cache_size += 2; });
    }' unless defined(&free_pgd_fast);
    eval 'sub free_pgd_slow {
        my($pgd) = @_;
	    eval q({  &free_pages( $pgd, 1); });
    }' unless defined(&free_pgd_slow);
    eval 'sub pgd_free {
        my($pgd) = @_;
	    eval q( &free_pgd_fast($pgd));
    }' unless defined(&pgd_free);
    eval 'sub pmd_alloc_one_fast {
        my($mm, $address) = @_;
	    eval q(({  &BUG(); (( &pmd_t *)1); }));
    }' unless defined(&pmd_alloc_one_fast);
    eval 'sub pmd_alloc_one {
        my($mm,$address) = @_;
	    eval q(({  &BUG(); (( &pmd_t *)2); }));
    }' unless defined(&pmd_alloc_one);
    eval 'sub pmd_free {
        my($x) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&pmd_free);
    eval 'sub pgd_populate {
        my($mm, $pmd, $pte) = @_;
	    eval q( &BUG());
    }' unless defined(&pgd_populate);
    eval 'sub pmd_populate {
        my($mm,$pmd,$pte) = @_;
	    eval q({  &pmd_val($pmd->[0]) =  &_PAGE_TABLE +  &__pa($pte);  &pmd_val($pmd->[1]) =  &_PAGE_TABLE +  &__pa($pte+256);  &pmd_val($pmd->[2]) =  &_PAGE_TABLE +  &__pa($pte+512);  &pmd_val($pmd->[3]) =  &_PAGE_TABLE +  &__pa($pte+768); });
    }' unless defined(&pmd_populate);
    eval 'sub pte_alloc_one_fast {
        my($mm,$address) = @_;
	    eval q({ my $long * &ret =  &pte_quicklist;  &if ( &ret !=  &NULL) {  &pte_quicklist = (* &ret);  $ret[0] =  $ret[1];  &pgtable_cache_size--; } ( &pte_t *) &ret; });
    }' unless defined(&pte_alloc_one_fast);
    eval 'sub pte_free_fast {
        my($pte) = @_;
	    eval q({ *$pte =  &pte_quicklist;  &pte_quicklist = $pte;  &pgtable_cache_size++; });
    }' unless defined(&pte_free_fast);
    eval 'sub pte_free_slow {
        my($pte) = @_;
	    eval q({  &free_page( $pte); });
    }' unless defined(&pte_free_slow);
    eval 'sub pte_free {
        my($pte) = @_;
	    eval q( &pte_free_fast($pte));
    }' unless defined(&pte_free);
    eval 'sub set_pgdir {
        my($addr,$entry) = @_;
	    eval q( &do { }  &while(0));
    }' unless defined(&set_pgdir);
    eval 'sub local_flush_tlb () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&local_flush_tlb);
    unless(defined(&CONFIG_SMP)) {
	eval 'sub flush_tlb_all {
	    my($void) = @_;
    	    eval q({  &local_flush_tlb(); });
	}' unless defined(&flush_tlb_all);
	eval 'sub flush_tlb_mm {
	    my($mm) = @_;
    	    eval q({  &local_flush_tlb(); });
	}' unless defined(&flush_tlb_mm);
	eval 'sub flush_tlb_page {
	    my($vma,$addr) = @_;
    	    eval q({  &local_flush_tlb(); });
	}' unless defined(&flush_tlb_page);
	eval 'sub flush_tlb_range {
	    my($mm,$start,$end) = @_;
    	    eval q({  &local_flush_tlb(); });
	}' unless defined(&flush_tlb_range);
    } else {
	require 'asm/smp.ph';
	eval 'sub global_flush_tlb_csp {
	    my($void) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&global_flush_tlb_csp);
	eval 'sub global_flush_tlb {
	    my($void) = @_;
    	    eval q({  &if ( &MACHINE_HAS_CSP)  &global_flush_tlb_csp();  &else  &smp_ptlb_all(); });
	}' unless defined(&global_flush_tlb);
	eval 'sub flush_tlb {
	    my($void) = @_;
    	    eval q({  &__flush_tlb_mm( ($current->{mm})); });
	}' unless defined(&flush_tlb);
	eval 'sub flush_tlb_all {
	    my($void) = @_;
    	    eval q({  &global_flush_tlb(); });
	}' unless defined(&flush_tlb_all);
	eval 'sub flush_tlb_mm {
	    my($mm) = @_;
    	    eval q({  &__flush_tlb_mm($mm); });
	}' unless defined(&flush_tlb_mm);
	eval 'sub flush_tlb_page {
	    my($vma,$addr) = @_;
    	    eval q({  &__flush_tlb_mm( ($vma->{vm_mm})); });
	}' unless defined(&flush_tlb_page);
	eval 'sub flush_tlb_range {
	    my($mm,$start,$end) = @_;
    	    eval q({  &__flush_tlb_mm($mm); });
	}' unless defined(&flush_tlb_range);
    }
    eval 'sub ptep_test_and_clear_and_flush_dirty {
        my($vma,$address,$ptep) = @_;
	    eval q({  &ptep_test_and_clear_dirty($ptep); });
    }' unless defined(&ptep_test_and_clear_and_flush_dirty);
    eval 'sub ptep_invalidate {
        my($vma,$address,$ptep) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&ptep_invalidate);
    eval 'sub ptep_establish {
        my($vma,$address,$ptep,$entry) = @_;
	    eval q({  &ptep_invalidate($vma, $address, $ptep);  &set_pte($ptep, $entry); });
    }' unless defined(&ptep_establish);
}
1;
