require '_h2ph_pre.ph';

no warnings 'redefine';

require 'linux/interrupt.ph';
require 'linux/spinlock.ph';
unless(defined(&kernel_locked)) {
    sub kernel_locked () {
	eval q( &spin_is_locked( &kernel_flag));
    }
}
unless(defined(&release_kernel_lock)) {
    sub release_kernel_lock {
	my($task, $cpu) = @_;
	eval q( &do {  &if ( ($task->{lock_depth}) >= 0)  &spin_unlock( &kernel_flag);  &release_irqlock($cpu);  &__sti(); }  &while (0));
    }
}
unless(defined(&reacquire_kernel_lock)) {
    sub reacquire_kernel_lock {
	my($task) = @_;
	eval q( &do {  &if ( ($task->{lock_depth}) >= 0)  &spin_lock( &kernel_flag); }  &while (0));
    }
}
unless(defined(&unlock_kernel)) {
    sub unlock_kernel {
	my($void) = @_;
	eval q({  &if (-- ($current->{lock_depth}) < 0)  &spin_unlock( &kernel_flag); });
    }
}
1;
