require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&EXT2_EXT_ATTR_MAGIC_v1)) {
    sub EXT2_EXT_ATTR_MAGIC_v1 () {	0xea010000;}
}
unless(defined(&EXT2_EXT_ATTR_MAGIC)) {
    sub EXT2_EXT_ATTR_MAGIC () {	0xea020000;}
}
unless(defined(&EXT2_EXT_ATTR_REFCOUNT_MAX)) {
    sub EXT2_EXT_ATTR_REFCOUNT_MAX () {	1024;}
}
unless(defined(&EXT2_EXT_ATTR_PAD_BITS)) {
    sub EXT2_EXT_ATTR_PAD_BITS () {	2;}
}
unless(defined(&EXT2_EXT_ATTR_PAD)) {
    sub EXT2_EXT_ATTR_PAD () {	(1<< &EXT2_EXT_ATTR_PAD_BITS);}
}
unless(defined(&EXT2_EXT_ATTR_ROUND)) {
    sub EXT2_EXT_ATTR_ROUND () {	( &EXT2_EXT_ATTR_PAD-1);}
}
unless(defined(&EXT2_EXT_ATTR_LEN)) {
    sub EXT2_EXT_ATTR_LEN {
	my($name_len) = @_;
	eval q(((($name_len) +  &EXT2_EXT_ATTR_ROUND + $sizeof{'struct ext2_ext_attr_entry'}) & ~ &EXT2_EXT_ATTR_ROUND));
    }
}
unless(defined(&EXT2_EXT_ATTR_NEXT)) {
    sub EXT2_EXT_ATTR_NEXT {
	my($entry) = @_;
	eval q(( ( ($entry) +  &EXT2_EXT_ATTR_LEN(($entry)-> &e_name_len)) ));
    }
}
unless(defined(&EXT2_EXT_ATTR_SIZE)) {
    sub EXT2_EXT_ATTR_SIZE {
	my($size) = @_;
	eval q(((($size) +  &EXT2_EXT_ATTR_ROUND) & ~ &EXT2_EXT_ATTR_ROUND));
    }
}
if(defined(&__KERNEL__)) {
    if(defined(&CONFIG_EXT2_FS_EXT_ATTR)) {
    } else {
	eval 'sub ext2_get_ext_attr () { &NULL;}' unless defined(&ext2_get_ext_attr);
	eval 'sub ext2_set_ext_attr () { &NULL;}' unless defined(&ext2_set_ext_attr);
    }
}
1;
