require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_HIGHUID_H)) {
    eval 'sub _LINUX_HIGHUID_H () {1;}' unless defined(&_LINUX_HIGHUID_H);
    require 'linux/config.ph';
    require 'linux/types.ph';
    eval 'sub DEFAULT_OVERFLOWUID () {65534;}' unless defined(&DEFAULT_OVERFLOWUID);
    eval 'sub DEFAULT_OVERFLOWGID () {65534;}' unless defined(&DEFAULT_OVERFLOWGID);
    if(defined(&CONFIG_UID16)) {
	eval 'sub high2lowuid {
	    my($uid) = @_;
    	    eval q((($uid) > 65535? ( &old_uid_t) &overflowuid : ( &old_uid_t)($uid)));
	}' unless defined(&high2lowuid);
	eval 'sub high2lowgid {
	    my($gid) = @_;
    	    eval q((($gid) > 65535? ( &old_gid_t) &overflowgid : ( &old_gid_t)($gid)));
	}' unless defined(&high2lowgid);
	eval 'sub low2highuid {
	    my($uid) = @_;
    	    eval q((($uid) == ( &old_uid_t)-1? ( &uid_t)-1: ( &uid_t)($uid)));
	}' unless defined(&low2highuid);
	eval 'sub low2highgid {
	    my($gid) = @_;
    	    eval q((($gid) == ( &old_gid_t)-1? ( &gid_t)-1: ( &gid_t)($gid)));
	}' unless defined(&low2highgid);
	eval 'sub SET_UID16 {
	    my($var, $uid) = @_;
    	    eval q($var =  &high2lowuid($uid));
	}' unless defined(&SET_UID16);
	eval 'sub SET_GID16 {
	    my($var, $gid) = @_;
    	    eval q($var =  &high2lowgid($gid));
	}' unless defined(&SET_GID16);
	eval 'sub NEW_TO_OLD_UID {
	    my($uid) = @_;
    	    eval q( &high2lowuid($uid));
	}' unless defined(&NEW_TO_OLD_UID);
	eval 'sub NEW_TO_OLD_GID {
	    my($gid) = @_;
    	    eval q( &high2lowgid($gid));
	}' unless defined(&NEW_TO_OLD_GID);
	eval 'sub SET_OLDSTAT_UID {
	    my($stat, $uid) = @_;
    	    eval q(($stat). &st_uid =  &high2lowuid($uid));
	}' unless defined(&SET_OLDSTAT_UID);
	eval 'sub SET_OLDSTAT_GID {
	    my($stat, $gid) = @_;
    	    eval q(($stat). &st_gid =  &high2lowgid($gid));
	}' unless defined(&SET_OLDSTAT_GID);
	eval 'sub SET_STAT_UID {
	    my($stat, $uid) = @_;
    	    eval q(($stat). &st_uid =  &high2lowuid($uid));
	}' unless defined(&SET_STAT_UID);
	eval 'sub SET_STAT_GID {
	    my($stat, $gid) = @_;
    	    eval q(($stat). &st_gid =  &high2lowgid($gid));
	}' unless defined(&SET_STAT_GID);
    } else {
	eval 'sub SET_UID16 {
	    my($var, $uid) = @_;
    	    eval q( &do { ; }  &while (0));
	}' unless defined(&SET_UID16);
	eval 'sub SET_GID16 {
	    my($var, $gid) = @_;
    	    eval q( &do { ; }  &while (0));
	}' unless defined(&SET_GID16);
	eval 'sub NEW_TO_OLD_UID {
	    my($uid) = @_;
    	    eval q(($uid));
	}' unless defined(&NEW_TO_OLD_UID);
	eval 'sub NEW_TO_OLD_GID {
	    my($gid) = @_;
    	    eval q(($gid));
	}' unless defined(&NEW_TO_OLD_GID);
	eval 'sub SET_OLDSTAT_UID {
	    my($stat, $uid) = @_;
    	    eval q(($stat). &st_uid = ($uid));
	}' unless defined(&SET_OLDSTAT_UID);
	eval 'sub SET_OLDSTAT_GID {
	    my($stat, $gid) = @_;
    	    eval q(($stat). &st_gid = ($gid));
	}' unless defined(&SET_OLDSTAT_GID);
	eval 'sub SET_STAT_UID {
	    my($stat, $uid) = @_;
    	    eval q(($stat). &st_uid = ($uid));
	}' unless defined(&SET_STAT_UID);
	eval 'sub SET_STAT_GID {
	    my($stat, $gid) = @_;
    	    eval q(($stat). &st_gid = ($gid));
	}' unless defined(&SET_STAT_GID);
    }
    eval 'sub DEFAULT_FS_OVERFLOWUID () {65534;}' unless defined(&DEFAULT_FS_OVERFLOWUID);
    eval 'sub DEFAULT_FS_OVERFLOWGID () {65534;}' unless defined(&DEFAULT_FS_OVERFLOWGID);
    eval 'sub fs_high2lowuid {
        my($uid) = @_;
	    eval q((($uid) > 65535? ( &uid16_t) &fs_overflowuid : ( &uid16_t)($uid)));
    }' unless defined(&fs_high2lowuid);
    eval 'sub fs_high2lowgid {
        my($gid) = @_;
	    eval q((($gid) > 65535? ( &gid16_t) &fs_overflowgid : ( &gid16_t)($gid)));
    }' unless defined(&fs_high2lowgid);
    eval 'sub low_16_bits {
        my($x) = @_;
	    eval q((($x) & 0xffff));
    }' unless defined(&low_16_bits);
    eval 'sub high_16_bits {
        my($x) = @_;
	    eval q(((($x) & 0xffff0000) >> 16));
    }' unless defined(&high_16_bits);
}
1;
