require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__MTD_MTD_H__)) {
    eval 'sub __MTD_MTD_H__ () {1;}' unless defined(&__MTD_MTD_H__);
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	require 'linux/version.ph';
	require 'linux/types.ph';
	require 'linux/mtd/compatmac.ph';
	require 'linux/module.ph';
	require 'linux/uio.ph';
    }
    eval 'sub MTD_CHAR_MAJOR () {90;}' unless defined(&MTD_CHAR_MAJOR);
    eval 'sub MTD_BLOCK_MAJOR () {31;}' unless defined(&MTD_BLOCK_MAJOR);
    eval 'sub MAX_MTD_DEVICES () {16;}' unless defined(&MAX_MTD_DEVICES);
    eval 'sub MTD_ABSENT () {0;}' unless defined(&MTD_ABSENT);
    eval 'sub MTD_RAM () {1;}' unless defined(&MTD_RAM);
    eval 'sub MTD_ROM () {2;}' unless defined(&MTD_ROM);
    eval 'sub MTD_NORFLASH () {3;}' unless defined(&MTD_NORFLASH);
    eval 'sub MTD_NANDFLASH () {4;}' unless defined(&MTD_NANDFLASH);
    eval 'sub MTD_PEROM () {5;}' unless defined(&MTD_PEROM);
    eval 'sub MTD_OTHER () {14;}' unless defined(&MTD_OTHER);
    eval 'sub MTD_UNKNOWN () {15;}' unless defined(&MTD_UNKNOWN);
    eval 'sub MTD_CLEAR_BITS () {1;}' unless defined(&MTD_CLEAR_BITS);
    eval 'sub MTD_SET_BITS () {2;}' unless defined(&MTD_SET_BITS);
    eval 'sub MTD_ERASEABLE () {4;}' unless defined(&MTD_ERASEABLE);
    eval 'sub MTD_WRITEB_WRITEABLE () {8;}' unless defined(&MTD_WRITEB_WRITEABLE);
    eval 'sub MTD_VOLATILE () {16;}' unless defined(&MTD_VOLATILE);
    eval 'sub MTD_XIP () {32;}' unless defined(&MTD_XIP);
    eval 'sub MTD_OOB () {64;}' unless defined(&MTD_OOB);
    eval 'sub MTD_ECC () {128;}' unless defined(&MTD_ECC);
    eval 'sub MTD_CAP_ROM () {0;}' unless defined(&MTD_CAP_ROM);
    eval 'sub MTD_CAP_RAM () {( &MTD_CLEAR_BITS| &MTD_SET_BITS| &MTD_WRITEB_WRITEABLE);}' unless defined(&MTD_CAP_RAM);
    eval 'sub MTD_CAP_NORFLASH () {( &MTD_CLEAR_BITS| &MTD_ERASEABLE);}' unless defined(&MTD_CAP_NORFLASH);
    eval 'sub MTD_CAP_NANDFLASH () {( &MTD_CLEAR_BITS| &MTD_ERASEABLE| &MTD_OOB);}' unless defined(&MTD_CAP_NANDFLASH);
    eval 'sub MTD_WRITEABLE () {( &MTD_CLEAR_BITS| &MTD_SET_BITS);}' unless defined(&MTD_WRITEABLE);
    eval 'sub MTD_ECC_NONE () {0;}' unless defined(&MTD_ECC_NONE);
    eval 'sub MTD_ECC_RS_DiskOnChip () {1;}' unless defined(&MTD_ECC_RS_DiskOnChip);
    eval 'sub MTD_ECC_SW () {2;}' unless defined(&MTD_ECC_SW);
    eval 'sub MEMGETINFO () { &_IOR(ord(\'M\'), 1, \'struct mtd_info_user\');}' unless defined(&MEMGETINFO);
    eval 'sub MEMERASE () { &_IOW(ord(\'M\'), 2, \'struct erase_info_user\');}' unless defined(&MEMERASE);
    eval 'sub MEMWRITEOOB () { &_IOWR(ord(\'M\'), 3, \'struct mtd_oob_buf\');}' unless defined(&MEMWRITEOOB);
    eval 'sub MEMREADOOB () { &_IOWR(ord(\'M\'), 4, \'struct mtd_oob_buf\');}' unless defined(&MEMREADOOB);
    eval 'sub MEMLOCK () { &_IOW(ord(\'M\'), 5, \'struct erase_info_user\');}' unless defined(&MEMLOCK);
    eval 'sub MEMUNLOCK () { &_IOW(ord(\'M\'), 6, \'struct erase_info_user\');}' unless defined(&MEMUNLOCK);
    eval 'sub MEMGETREGIONCOUNT () { &_IOR(ord(\'M\'), 7, \'int\');}' unless defined(&MEMGETREGIONCOUNT);
    eval 'sub MEMGETREGIONINFO () { &_IOWR(ord(\'M\'), 8, \'struct region_info_user\');}' unless defined(&MEMGETREGIONINFO);
    unless(defined(&__KERNEL__)) {
    } else {
	eval 'sub MTD_ERASE_PENDING () {0x1;}' unless defined(&MTD_ERASE_PENDING);
	eval 'sub MTD_ERASING () {0x2;}' unless defined(&MTD_ERASING);
	eval 'sub MTD_ERASE_SUSPEND () {0x4;}' unless defined(&MTD_ERASE_SUSPEND);
	eval 'sub MTD_ERASE_DONE () {0x8;}' unless defined(&MTD_ERASE_DONE);
	eval 'sub MTD_ERASE_FAILED () {0x10;}' unless defined(&MTD_ERASE_FAILED);
	eval 'sub mtd_info {
	    eval q(* &get_mtd_device(\'struct mtd_info\' * &mtd, \'int\'  &num) { \'struct mtd_info\' * &ret;  &ret =  &__get_mtd_device( &mtd,  &num);  &if ( &ret  &&  ($ret->{module})  && ! &try_inc_mod_count( ($ret->{module})))  &NULL;  &ret; });
	}' unless defined(&mtd_info);
	eval 'sub put_mtd_device {
	    my($mtd) = @_;
    	    eval q({  &if ( ($mtd->{module}))  &__MOD_DEC_USE_COUNT( ($mtd->{module})); });
	}' unless defined(&put_mtd_device);
	unless(defined(&MTDC)) {
	    eval 'sub MTD_ERASE () {( &mtd,  &args...) (*( ($mtd->{erase})))( &mtd,  &args);}' unless defined(&MTD_ERASE);
	    eval 'sub MTD_POINT {
	        my($mtd, $a,$b,$c,$d) = @_;
    		eval q((*( ($mtd->{point})))($mtd, $a,$b,$c, ($d)));
	    }' unless defined(&MTD_POINT);
	    eval 'sub MTD_UNPOINT {
	        my($mtd, $arg) = @_;
    		eval q((*( ($mtd->{unpoint})))($mtd, $arg));
	    }' unless defined(&MTD_UNPOINT);
	    eval 'sub MTD_READ () {( &mtd,  &args...) (*( ($mtd->{read})))( &mtd,  &args);}' unless defined(&MTD_READ);
	    eval 'sub MTD_WRITE () {( &mtd,  &args...) (*( ($mtd->{write})))( &mtd,  &args);}' unless defined(&MTD_WRITE);
	    eval 'sub MTD_READV () {( &mtd,  &args...) (*( ($mtd->{readv})))( &mtd,  &args);}' unless defined(&MTD_READV);
	    eval 'sub MTD_WRITEV () {( &mtd,  &args...) (*( ($mtd->{writev})))( &mtd,  &args);}' unless defined(&MTD_WRITEV);
	    eval 'sub MTD_READECC () {( &mtd,  &args...) (*( ($mtd->{read_ecc})))( &mtd,  &args);}' unless defined(&MTD_READECC);
	    eval 'sub MTD_WRITEECC () {( &mtd,  &args...) (*( ($mtd->{write_ecc})))( &mtd,  &args);}' unless defined(&MTD_WRITEECC);
	    eval 'sub MTD_READOOB () {( &mtd,  &args...) (*( ($mtd->{read_oob})))( &mtd,  &args);}' unless defined(&MTD_READOOB);
	    eval 'sub MTD_WRITEOOB () {( &mtd,  &args...) (*( ($mtd->{write_oob})))( &mtd,  &args);}' unless defined(&MTD_WRITEOOB);
	    eval 'sub MTD_SYNC {
	        my($mtd) = @_;
    		eval q( &do {  &if ( ($mtd->{sync})) (*( ($mtd->{sync})))($mtd); }  &while (0));
	    }' unless defined(&MTD_SYNC);
	}
	eval 'sub MTD_DEBUG_LEVEL0 () {(0);}' unless defined(&MTD_DEBUG_LEVEL0);
	eval 'sub MTD_DEBUG_LEVEL1 () {(1);}' unless defined(&MTD_DEBUG_LEVEL1);
	eval 'sub MTD_DEBUG_LEVEL2 () {(2);}' unless defined(&MTD_DEBUG_LEVEL2);
	eval 'sub MTD_DEBUG_LEVEL3 () {(3);}' unless defined(&MTD_DEBUG_LEVEL3);
	if(defined(&CONFIG_MTD_DEBUG)) {
	    eval 'sub DEBUG () {( &n,  &args...)  &if ( &n <=  &CONFIG_MTD_DEBUG_VERBOSE) {  &printk( &KERN_INFO  &args); };}' unless defined(&DEBUG);
	} else {
	    eval 'sub DEBUG () {( &n,  &args...);}' unless defined(&DEBUG);
	}
    }
}
1;
