require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_QUOTA_H)) {
    eval 'sub _SYS_QUOTA_H () {1;}' unless defined(&_SYS_QUOTA_H);
    require 'features.ph';
    require 'sys/types.ph';
    unless(defined(&_LINUX_QUOTA_VERSION)) {
	eval 'sub _LINUX_QUOTA_VERSION () {1;}' unless defined(&_LINUX_QUOTA_VERSION);
    }
    eval 'sub dbtob {
        my($num) = @_;
	    eval q((($num) << 10));
    }' unless defined(&dbtob);
    eval 'sub btodb {
        my($num) = @_;
	    eval q((($num) >> 10));
    }' unless defined(&btodb);
    eval 'sub fs_to_dq_blocks {
        my($num, $blksize) = @_;
	    eval q(((($num) * ($blksize)) /  &BLOCK_SIZE));
    }' unless defined(&fs_to_dq_blocks);
    eval 'sub MAX_IQ_TIME () {604800;}' unless defined(&MAX_IQ_TIME);
    eval 'sub MAX_DQ_TIME () {604800;}' unless defined(&MAX_DQ_TIME);
    eval 'sub MAXQUOTAS () {2;}' unless defined(&MAXQUOTAS);
    eval 'sub USRQUOTA () {0;}' unless defined(&USRQUOTA);
    eval 'sub GRPQUOTA () {1;}' unless defined(&GRPQUOTA);
    eval 'sub INITQFNAMES () {{ "user", "group", "undefined", };;}' unless defined(&INITQFNAMES);
    eval 'sub QUOTAFILENAME () {"quota";}' unless defined(&QUOTAFILENAME);
    eval 'sub QUOTAGROUP () {"staff";}' unless defined(&QUOTAGROUP);
    eval 'sub NR_DQHASH () {43;}' unless defined(&NR_DQHASH);
    eval 'sub NR_DQUOTS () {256;}' unless defined(&NR_DQUOTS);
    eval 'sub SUBCMDMASK () {0xff;}' unless defined(&SUBCMDMASK);
    eval 'sub SUBCMDSHIFT () {8;}' unless defined(&SUBCMDSHIFT);
    eval 'sub QCMD {
        my($cmd, $type) = @_;
	    eval q(((($cmd) <<  &SUBCMDSHIFT) | (($type) &  &SUBCMDMASK)));
    }' unless defined(&QCMD);
    if((defined(&_LINUX_QUOTA_VERSION) ? &_LINUX_QUOTA_VERSION : 0) < 2) {
	eval 'sub Q_QUOTAON () {0x100;}' unless defined(&Q_QUOTAON);
	eval 'sub Q_QUOTAOFF () {0x200;}' unless defined(&Q_QUOTAOFF);
	eval 'sub Q_GETQUOTA () {0x300;}' unless defined(&Q_GETQUOTA);
	eval 'sub Q_SETQUOTA () {0x400;}' unless defined(&Q_SETQUOTA);
	eval 'sub Q_SETUSE () {0x500;}' unless defined(&Q_SETUSE);
	eval 'sub Q_SYNC () {0x600;}' unless defined(&Q_SYNC);
	eval 'sub Q_SETQLIM () {0x700;}' unless defined(&Q_SETQLIM);
	eval 'sub Q_GETSTATS () {0x800;}' unless defined(&Q_GETSTATS);
	eval 'sub Q_RSQUASH () {0x1000;}' unless defined(&Q_RSQUASH);
    } else {
	eval 'sub Q_SYNC () {0x800001;}' unless defined(&Q_SYNC);
	eval 'sub Q_QUOTAON () {0x800002;}' unless defined(&Q_QUOTAON);
	eval 'sub Q_QUOTAOFF () {0x800003;}' unless defined(&Q_QUOTAOFF);
	eval 'sub Q_GETFMT () {0x800004;}' unless defined(&Q_GETFMT);
	eval 'sub Q_GETINFO () {0x800005;}' unless defined(&Q_GETINFO);
	eval 'sub Q_SETINFO () {0x800006;}' unless defined(&Q_SETINFO);
	eval 'sub Q_GETQUOTA () {0x800007;}' unless defined(&Q_GETQUOTA);
	eval 'sub Q_SETQUOTA () {0x800008;}' unless defined(&Q_SETQUOTA);
    }
    if((defined(&_LINUX_QUOTA_VERSION) ? &_LINUX_QUOTA_VERSION : 0) < 2) {
    } else {
	eval 'sub QIF_BLIMITS () {1;}' unless defined(&QIF_BLIMITS);
	eval 'sub QIF_SPACE () {2;}' unless defined(&QIF_SPACE);
	eval 'sub QIF_ILIMITS () {4;}' unless defined(&QIF_ILIMITS);
	eval 'sub QIF_INODES () {8;}' unless defined(&QIF_INODES);
	eval 'sub QIF_BTIME () {16;}' unless defined(&QIF_BTIME);
	eval 'sub QIF_ITIME () {32;}' unless defined(&QIF_ITIME);
	eval 'sub QIF_LIMITS () {( &QIF_BLIMITS |  &QIF_ILIMITS);}' unless defined(&QIF_LIMITS);
	eval 'sub QIF_USAGE () {( &QIF_SPACE |  &QIF_INODES);}' unless defined(&QIF_USAGE);
	eval 'sub QIF_TIMES () {( &QIF_BTIME |  &QIF_ITIME);}' unless defined(&QIF_TIMES);
	eval 'sub QIF_ALL () {( &QIF_LIMITS |  &QIF_USAGE |  &QIF_TIMES);}' unless defined(&QIF_ALL);
    }
    eval 'sub dq_bhardlimit () { ($dq_dqb->{dqb_bhardlimit});}' unless defined(&dq_bhardlimit);
    eval 'sub dq_bsoftlimit () { ($dq_dqb->{dqb_bsoftlimit});}' unless defined(&dq_bsoftlimit);
    if((defined(&_LINUX_QUOTA_VERSION) ? &_LINUX_QUOTA_VERSION : 0) < 2) {
	eval 'sub dq_curblocks () { ($dq_dqb->{dqb_curblocks});}' unless defined(&dq_curblocks);
    } else {
	eval 'sub dq_curspace () { ($dq_dqb->{dqb_curspace});}' unless defined(&dq_curspace);
	eval 'sub dq_valid () { ($dq_dqb->{dqb_valid});}' unless defined(&dq_valid);
    }
    eval 'sub dq_ihardlimit () { ($dq_dqb->{dqb_ihardlimit});}' unless defined(&dq_ihardlimit);
    eval 'sub dq_isoftlimit () { ($dq_dqb->{dqb_isoftlimit});}' unless defined(&dq_isoftlimit);
    eval 'sub dq_curinodes () { ($dq_dqb->{dqb_curinodes});}' unless defined(&dq_curinodes);
    eval 'sub dq_btime () { ($dq_dqb->{dqb_btime});}' unless defined(&dq_btime);
    eval 'sub dq_itime () { ($dq_dqb->{dqb_itime});}' unless defined(&dq_itime);
    eval 'sub dqoff {
        my($UID) = @_;
	    eval q((( &loff_t)(($UID) * $sizeof{\'struct dqblk\'})));
    }' unless defined(&dqoff);
    if((defined(&_LINUX_QUOTA_VERSION) ? &_LINUX_QUOTA_VERSION : 0) < 2) {
    } else {
	eval 'sub IIF_BGRACE () {1;}' unless defined(&IIF_BGRACE);
	eval 'sub IIF_IGRACE () {2;}' unless defined(&IIF_IGRACE);
	eval 'sub IIF_FLAGS () {4;}' unless defined(&IIF_FLAGS);
	eval 'sub IIF_ALL () {( &IIF_BGRACE |  &IIF_IGRACE |  &IIF_FLAGS);}' unless defined(&IIF_ALL);
    }
}
1;
